"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsSqlInit = void 0;
var sql = require("mssql");
var log4js = require("log4js");
var mssql_config_1 = require("../config/mssql.config");
var auth_mssql_1 = require("./mssql/auth.mssql");
var auditor_evaluation_plan_mssql_1 = require("./mssql/auditor-evaluation-plan.mssql");
var batch_mssql_1 = require("./mssql/batch.mssql");
var batch_error_mssql_1 = require("./mssql/batch-error.mssql");
var batch_schedule_mssql_1 = require("./mssql/batch-schedule.mssql");
var custom_field_mssql_1 = require("./mssql/custom-field.mssql");
var diarization_mssql_1 = require("./mssql/diarization.mssql");
var dictionary_mssql_1 = require("./mssql/dictionary.mssql");
var domain_mssql_1 = require("./mssql/domain.mssql");
var entity_mssql_1 = require("./mssql/entity.mssql");
var evaluation_tipification_mssql_1 = require("./mssql/evaluation-tipification.mssql");
var interaction_evaluation_plan_mssql_1 = require("./mssql/interaction-evaluation-plan.mssql");
var sentiment_mssql_1 = require("./mssql/sentiment.mssql");
var team_performance_mssql_1 = require("./mssql/team-performance.mssql");
var tipification_mssql_1 = require("./mssql/tipification.mssql");
var vcc_mssql_1 = require("./mssql/vcc.mssql");
var vcc_license_mssql_1 = require("./mssql/vcc-license.mssql");
var home_mssql_1 = require("./mssql/home.mssql");
var notification_mssql_1 = require("./mssql/notification.mssql");
var profile_image_mssql_1 = require("./mssql/profile-image.mssql");
var report_mssql_1 = require("./mssql/report.mssql");
var role_mssql_1 = require("./mssql/role.mssql");
var user_mssql_1 = require("./mssql/user.mssql");
var api_user_mssql_1 = require("./mssql/api-user.mssql");
var azure_subscription_mssql_1 = require("./mssql/azure-subscription.mssql");
var client_mssql_1 = require("./mssql/client.mssql");
var process_mssql_1 = require("./mssql/process.mssql");
var exception_mssql_1 = require("./mssql/exception.mssql");
var environment_mssql_1 = require("./mssql/environment.mssql");
var allegro_mssql_1 = require("./mssql/allegro.mssql");
var audio_mssql_1 = require("./mssql/audio.mssql");
var idatha_mssql_1 = require("./mssql/idatha.mssql");
var feeling_mssql_1 = require("./mssql/feeling.mssql");
var category_mssql_1 = require("./mssql/category.mssql");
var neuro_linguistic_programming_mssql_1 = require("./mssql/neuro-linguistic-programming.mssql");
var template_mssql_1 = require("./mssql/template.mssql");
var custom_template_mssql_1 = require("./mssql/custom-template.mssql");
var generic_template_mssql_1 = require("./mssql/generic-template.mssql");
var generic_query_mssql_1 = require("./mssql/generic-query.mssql");
var nlu_mssql_1 = require("./mssql/nlu.mssql");
var intent_mssql_1 = require("./mssql/intent.mssql");
var utterance_mssql_1 = require("./mssql/utterance.mssql");
var tag_mssql_1 = require("./mssql/tag.mssql");
var study_mssql_1 = require("./mssql/study.mssql");
var word_blacklist_mssql_1 = require("./mssql/word-blacklist.mssql");
var integration_mssql_1 = require("./mssql/integration.mssql");
var campaign_fulfillment_mssql_1 = require("./mssql/campaign-fulfillment.mssql");
var average_group_rating_mssql_1 = require("./mssql/average-group-rating.mssql");
var average_group_rating_norm_mssql_1 = require("./mssql/average-group-rating-norm.mssql");
var top_best_agents_mssql_1 = require("./mssql/top-best-agents.mssql");
var top_worst_agents_mssql_1 = require("./mssql/top-worst-agents.mssql");
var ability_mssql_1 = require("./mssql/ability.mssql");
var subgroup_mssql_1 = require("./mssql/subgroup.mssql");
var group_mssql_1 = require("./mssql/group.mssql");
var evaluation_format_mssql_1 = require("./mssql/evaluation-format.mssql");
var campain_mssql_1 = require("./mssql/campain.mssql");
var workgroup_mssql_1 = require("./mssql/workgroup.mssql");
var attentionlevel_mssql_1 = require("./mssql/attentionlevel.mssql");
var interaction_mssql_1 = require("./mssql/interaction.mssql");
var evaluation_plan_mssql_1 = require("./mssql/evaluation-plan.mssql");
var interaction_type_mssql_1 = require("./mssql/interaction-type.mssql");
var evaluation_mssql_1 = require("./mssql/evaluation.mssql");
var evaluation_review_mssql_1 = require("./mssql/evaluation-review.mssql");
var auditor_mssql_1 = require("./mssql/auditor.mssql");
var agent_mssql_1 = require("./mssql/agent.mssql");
var interactions_by_type_mssql_1 = require("./mssql/interactions-by-type.mssql");
var supervisor_mssql_1 = require("./mssql/supervisor.mssql");
var tenant_vcc_mssql_1 = require("./mssql/tenant-vcc.mssql");
var version_mssql_1 = require("./mssql/version.mssql");
var async_interaction_mssql_1 = require("./mssql/async-interaction.mssql");
var disposition_code_mssql_1 = require("./mssql/disposition-code.mssql");
var global_search_mssql_1 = require("./mssql/global-search.mssql");
var workgroupsupervisor_mssql_1 = require("./mssql/workgroupsupervisor.mssql");
var logger = log4js.getLogger('Sql');
function MsSqlInit(app) {
    return new Promise(function (resolve, reject) {
        logger.info('Iniciando conexión a base de datos \'' + mssql_config_1.MSSQL_CONFIG.server + '\'');
        console.log('Iniciando conexión a base de datos \'' + mssql_config_1.MSSQL_CONFIG.server + '\'');
        var sqlConn = new sql.Connection(mssql_config_1.MSSQL_CONFIG, function (err) {
            if (err) {
                var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
                logger.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                console.error('No se pudo establecer conexion a base de datos: ' + errMsg);
                reject(err);
            }
            else {
                logger.info('Conexión a base de datos establecida');
                console.log('Conexión a base de datos establecida');
                resolve(true);
            }
        });
        app.set('sqlConn', sqlConn);
        (0, auth_mssql_1.AuthMSSql)(app);
        (0, auditor_evaluation_plan_mssql_1.AuditorEvaluationPlanMSSql)(app);
        (0, batch_mssql_1.BatchMSSql)(app);
        (0, batch_error_mssql_1.BatchErrorMSSql)(app);
        (0, batch_schedule_mssql_1.BatchScheduleMSSql)(app);
        (0, custom_field_mssql_1.CustomFieldMSSql)(app);
        (0, diarization_mssql_1.DiarizationMSSql)(app);
        (0, dictionary_mssql_1.DictionaryMSSql)(app);
        (0, domain_mssql_1.DomainMSSql)(app);
        (0, entity_mssql_1.EntityMSSql)(app);
        (0, evaluation_tipification_mssql_1.EvaluationTipificationMSSql)(app);
        (0, interaction_evaluation_plan_mssql_1.InteractionEvaluationPlanMSSql)(app);
        (0, sentiment_mssql_1.SentimentMSSql)(app);
        (0, team_performance_mssql_1.TeamPerformanceMSSql)(app);
        (0, tipification_mssql_1.TipificationMSSql)(app),
            (0, vcc_mssql_1.VCCMSSql)(app);
        (0, vcc_license_mssql_1.VCCLicenseMSSql)(app);
        (0, home_mssql_1.HomeMSSql)(app);
        (0, notification_mssql_1.NotificationMSSql)(app);
        (0, profile_image_mssql_1.ProfileImageMSSql)(app);
        (0, report_mssql_1.ReportMSSql)(app);
        (0, role_mssql_1.RoleMSSql)(app);
        (0, user_mssql_1.UserMSSql)(app);
        (0, api_user_mssql_1.ApiUserMSSql)(app);
        (0, azure_subscription_mssql_1.AzureSubscriptionMSSql)(app);
        (0, client_mssql_1.ClientMSSql)(app);
        (0, process_mssql_1.ProcessMSSql)(app);
        (0, exception_mssql_1.ExceptionMSSql)(app);
        (0, environment_mssql_1.EnvironmentMSSql)(app);
        (0, allegro_mssql_1.AllegroMSSql)(app);
        (0, audio_mssql_1.AudiosMSSql)(app);
        (0, idatha_mssql_1.IdathaMSSql)(app);
        (0, feeling_mssql_1.FeelingMSSql)(app);
        (0, category_mssql_1.CategoryMSSql)(app);
        (0, neuro_linguistic_programming_mssql_1.NeuroLinguisticProgrammingMSSql)(app);
        (0, template_mssql_1.TemplateMSSql)(app);
        (0, custom_template_mssql_1.CustomTemplateMSSql)(app);
        (0, generic_template_mssql_1.GenericTemplateMSSql)(app);
        (0, generic_query_mssql_1.GenericQueryMSSql)(app);
        (0, nlu_mssql_1.NLUMSSql)(app);
        (0, intent_mssql_1.IntentMSSql)(app);
        (0, utterance_mssql_1.UtteranceMSSql)(app);
        (0, tag_mssql_1.TagMSSql)(app);
        (0, study_mssql_1.StudyMSSql)(app);
        (0, word_blacklist_mssql_1.WordBlacklistMSSql)(app);
        (0, integration_mssql_1.IntegrationMSSql)(app);
        (0, campaign_fulfillment_mssql_1.CampaignFulfillmentMssql)(app);
        (0, average_group_rating_mssql_1.AverageGroupRatingMssql)(app);
        (0, average_group_rating_norm_mssql_1.AverageGroupRatingNormMssql)(app);
        (0, top_best_agents_mssql_1.TopBestAgentsMssql)(app);
        (0, top_worst_agents_mssql_1.TopWorstAgentsMssql)(app);
        (0, interactions_by_type_mssql_1.InteractionsByTypeMSSql)(app);
        (0, ability_mssql_1.AbilityMSSql)(app);
        (0, subgroup_mssql_1.SubgroupMSSql)(app);
        (0, group_mssql_1.GroupMSSql)(app);
        (0, evaluation_format_mssql_1.EvaluationFormatMSSql)(app);
        (0, campain_mssql_1.CampainMSSql)(app);
        (0, disposition_code_mssql_1.DispositionCodeMSSql)(app);
        (0, workgroup_mssql_1.WorkGroupMSSql)(app);
        (0, attentionlevel_mssql_1.AttentionLevelMSSql)(app);
        (0, interaction_mssql_1.InteractionMSSql)(app);
        (0, evaluation_plan_mssql_1.EvaluationPlanMSSql)(app);
        (0, interaction_type_mssql_1.InteractionTypeMSSql)(app);
        (0, evaluation_mssql_1.EvaluationMSSql)(app);
        (0, evaluation_review_mssql_1.EvaluationReviewMSSql)(app);
        (0, auditor_mssql_1.AuditorMSSql)(app);
        (0, agent_mssql_1.AgentMSSql)(app);
        (0, version_mssql_1.VersionMSSql)(app);
        (0, api_user_mssql_1.ApiUserMSSql)(app);
        (0, supervisor_mssql_1.SupervisorMSSql)(app);
        (0, tenant_vcc_mssql_1.TenantVCCMSSql)(app);
        (0, async_interaction_mssql_1.AsyncInteractionMSSql)(app);
        (0, global_search_mssql_1.GlobalSearchMSSql)(app);
        (0, workgroupsupervisor_mssql_1.WorkGroupSupervisorMSSql)(app);
    });
}
exports.MsSqlInit = MsSqlInit;
