"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetHistoricCampaigns = exports.GetCampaignQualificationAverage = exports.GetCampaignsEvaluationFormat = exports.GetCampaignsFromEvaluation = exports.CampainMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function CampainMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.CampainMSSql = CampainMSSql;
function GetCampaignsFromEvaluation(vcc, userId, searchType) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('SearchType', sql.VarChar(50), searchType)
        .execute('GetCampaignsFromEvaluation')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetCampaignsFromEvaluation = GetCampaignsFromEvaluation;
function GetCampaignsEvaluationFormat(instance, IdEvaluationFormat) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), IdEvaluationFormat)
        .execute('GetCampaignsEvaluationFormat')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetCampaignsEvaluationFormat = GetCampaignsEvaluationFormat;
function GetCampaignQualificationAverage(instance, idCampaign) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdCampaign', sql.VarChar(100), idCampaign)
        .execute('GetCampaignQualificationAverage')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetCampaignQualificationAverage = GetCampaignQualificationAverage;
function GetHistoricCampaigns(vcc, excludesWorkGroupSup) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ExcludesWorkGroupSup', sql.Bit, excludesWorkGroupSup)
        .execute('GetHistoricCampaigns')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetHistoricCampaigns = GetHistoricCampaigns;
