"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateStatusEvaluationPlan = exports.GetEvaluationResultEfectivitySummary = exports.GetFiltersFromEvaluation = exports.CleanFailedEvaluationPlanData = exports.GetEvaluationPlanTipificationInteractionTask = exports.GetEvaluationPlanCognitiveInteractionTask = exports.GetEvaluationPlanAbilityGenericQueryTask = exports.GetEvaluationPlanTask = exports.DeleteEvaluationPlan = exports.SaveInteractionEvaluationPlanSample = exports.SaveAuditorEvPlanResult = exports.SaveEvaluationPlanCompleted = exports.DeleteAuditorEvaluationPlanByInteraction = exports.DeleteAuditorEvaluationPlan = exports.GetAuditorsEvaluationPlan = exports.GetEvaluationPlan = exports.SaveEvaluationEfectivitySample = exports.SaveEvaluationPlan = exports.GetEvaluationPlansAgent = exports.GetEfectivityPlansAuditor = exports.GetEvaluationPlansAuditor = exports.GetEvaluationPlansSummary = exports.GetEvaluationPlanAbilityEvaluationFormats = exports.GetEvaluationPlanScores = exports.GetEvaluationPlanAbilitiesQueriesEntities = exports.GetEvaluationPlanAbilitiesQueries = exports.GetEvaluationPlanAbilities = exports.GetEvaluationPlanSubGroups = exports.GetEvaluationPlanGroups = exports.GetEvaluationPlanByInteractionId = exports.GetEvaluationPlanByProcessId = exports.GetEvaluationPlanByName = exports.GetEfectivityPlans = exports.GetEvaluationPlans = exports.GetEvaluationPlansExpired = exports.EvaluationPlanMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var score_model_1 = require("../../models/score.model");
var response_1 = require("../utils/response");
var logger = log4js.getLogger('Sql');
var sqlConn;
function EvaluationPlanMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.EvaluationPlanMSSql = EvaluationPlanMSSql;
function GetEvaluationPlansExpired() {
    return new sql.Request(sqlConn)
        .execute('GetEvaluationPlansExpired')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansExpired = GetEvaluationPlansExpired;
function GetEvaluationPlans(instance, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetEvaluationPlans')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlans = GetEvaluationPlans;
function GetEfectivityPlans(instance, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetEfectivityPlans')
        .then(function (recordsets) {
        var allevaluationRecordSets = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var efectivityPlansRecordSets = (recordsets && recordsets.length > 0 ? recordsets[1] : null);
        return Promise.resolve({
            allEvaluation: allevaluationRecordSets,
            efectivityPlans: efectivityPlansRecordSets
        });
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEfectivityPlans = GetEfectivityPlans;
function GetEvaluationPlanByName(vcc, description) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Searching if exists evaluation plan: ' + description + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Description', sql.VarChar(50), description)
        .execute('GetEvaluationPlanByName')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByName] Evaluation plan: ' + description + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByName] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByName = GetEvaluationPlanByName;
function GetEvaluationPlanByProcessId(vcc, processId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Searching if exists evaluation plan with ProcessId: ' + processId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('instance', sql.VarChar(50), vcc)
        .input('ProcessId', sql.VarChar(50), processId)
        .execute('GetEvaluationPlanByProcessId')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] Evaluation plan processId: ' + processId + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByProcessId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByProcessId = GetEvaluationPlanByProcessId;
function GetEvaluationPlanByInteractionId(vcc, interactionId) {
    logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Searching if exists evaluation plan with InteractionId: ' + interactionId + ' for VCC ' + vcc);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationPlanByInteractionId')
        .then(function (recordsets) {
        logger.debug('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] Evaluation plan interactionId: ' + interactionId + ' for VCC ' + vcc + ' exists.');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanByInteractionId] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanByInteractionId = GetEvaluationPlanByInteractionId;
function GetEvaluationPlanGroups(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanGroups')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanGroups = GetEvaluationPlanGroups;
function GetEvaluationPlanSubGroups(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanSubGroups')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanSubGroups = GetEvaluationPlanSubGroups;
function GetEvaluationPlanAbilities(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilities')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilities = GetEvaluationPlanAbilities;
function GetEvaluationPlanAbilitiesQueries(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilitiesQueries')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilitiesQueries = GetEvaluationPlanAbilitiesQueries;
function GetEvaluationPlanAbilitiesQueriesEntities(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilitiesQueriesEntities')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilitiesQueriesEntities = GetEvaluationPlanAbilitiesQueriesEntities;
function GetEvaluationPlanScores(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanScores')
        .then(function (recordsets) {
        var abilityScoreRecordset = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null;
        var abilityScoreTipificationRecordset = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 1 ? recordsets[1] : null;
        var abilityScoreTipificationQueryRecordset = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 2 ? recordsets[2] : null;
        var abilityScoreTipificationItemRecordset = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 3 ? recordsets[3] : null;
        abilityScoreTipificationRecordset.forEach(function (ast) {
            ast.tipificationQuery = abilityScoreTipificationQueryRecordset.find(function (astq) { return astq.tipificationId === ast.id; }) || new score_model_1.ScoreTipificationQuery();
            ast.items = abilityScoreTipificationItemRecordset.filter(function (asti) { return asti.tipificationId === ast.id && asti.scoreId === ast.scoreId; });
        });
        abilityScoreRecordset.forEach(function (as) {
            as.tipifications = abilityScoreTipificationRecordset.filter(function (ast) { return ast.scoreId === as.id; });
        });
        return Promise.resolve(abilityScoreRecordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanScores = GetEvaluationPlanScores;
function GetEvaluationPlanAbilityEvaluationFormats(vcc, evaluationPlanId) {
    if (evaluationPlanId === void 0) { evaluationPlanId = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilityEvaluationFormats')
        .then(function (recordsets) {
        var abilityEvaluationFormatRecordset = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null;
        return Promise.resolve(abilityEvaluationFormatRecordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilityEvaluationFormats = GetEvaluationPlanAbilityEvaluationFormats;
function GetEvaluationPlansSummary(instance, isAdmin, idAgent, idAuditor, campaigns, limitDate, evaluationFormats, modalities, completed) {
    var request = new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), instance)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed);
    if (!isAdmin) {
        if (idAuditor != null)
            request.input('IdAuditor', sql.VarChar(sql.MAX), idAuditor);
        if (idAgent != null)
            request.input('IdAgent', sql.VarChar(sql.MAX), idAgent);
    }
    return request.execute('GetEvaluationPlansSummary')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Requesting error \'' + err.procName + '\': ' : 'Error on: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[evaluation-plan.mssql::GetEvaluationPlansMaster] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansSummary = GetEvaluationPlansSummary;
function GetEvaluationPlansAuditor(instance, userId, campaigns, limitDate, evaluationPlans, evaluationFormats, modalities, completed, userFuntion) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(sql.MAX), userId)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit(), completed)
        .input('UserFunction', sql.VarChar(50), userFuntion)
        .execute('GetEvaluationPlansAuditor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAuditor = GetEvaluationPlansAuditor;
function GetEfectivityPlansAuditor(instance, userId, campaigns, evaluationPlans, completed, userFuntion, efectivityPlans) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(sql.MAX), userId)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('Completed', sql.Bit(), completed)
        .input('UserFunction', sql.VarChar(50), userFuntion)
        .input('EfectivityPlans', sql.VarChar(sql.MAX), efectivityPlans)
        .execute('GetEfectivityPlansAuditor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEfectivityPlansAuditor = GetEfectivityPlansAuditor;
function GetEvaluationPlansAgent(instance, idAgent, campaigns, limitDate, evaluationFormats, modalities, completed) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAgent', sql.VarChar(sql.MAX), idAgent)
        .input('EndDate', sql.VarChar(50), limitDate)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationFormats', sql.VarChar(sql.MAX), evaluationFormats)
        .input('Modalities', sql.VarChar(sql.MAX), modalities)
        .input('Completed', sql.Bit, completed)
        .execute('GetEvaluationPlansAgent')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlansAgent = GetEvaluationPlansAgent;
function SaveEvaluationPlan(instance, id, modality, dateFin, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, idEvaluationFormat, transcriptionLanguage, environmentId, description, enabled, filterByContent, filterByContentPercentage, evaluatePercentage, processAndEvaluate, filterByContentQueryName, filterByContentQuery, evaluationStarted, processId, status, evaluation_mode, batchScheduleId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), id)
        .input('Modality', sql.VarChar(50), modality)
        .input('DateFin', sql.DateTime, dateFin)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('TranscriptionLanguage', sql.VarChar(25), transcriptionLanguage)
        .input('EnvironmentId', sql.VarChar(100), environmentId)
        .input('Description', sql.VarChar(200), description)
        .input('Enabled', sql.Bit(), enabled)
        .input('FilterByContent', sql.Bit(), filterByContent)
        .input('FilterByContentPercentage', sql.Numeric(3), filterByContentPercentage)
        .input('EvaluatePercentage', sql.Numeric(3), evaluatePercentage)
        .input('ProcessAndEvaluate', sql.Bit(), processAndEvaluate)
        .input('FilterByContentQueryName', sql.VarChar(50), filterByContentQueryName)
        .input('FilterByContentQuery', sql.VarChar(1000), filterByContentQuery)
        .input('EvaluationStarted', sql.Bit(), evaluationStarted)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Status', sql.Numeric(2), status)
        .input('Evaluation_Mode', sql.VarChar(10), evaluation_mode)
        .input('BatchScheduleId', sql.VarChar(50), batchScheduleId)
        .execute('SaveEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveEvaluationPlan] Success request');
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlan = SaveEvaluationPlan;
function SaveEvaluationEfectivitySample(vcc, efectivityPlanId, evaluationPlanId, auditorId, sampleSize) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EfectivityPlanId', sql.VarChar(50), efectivityPlanId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('AuditorId', sql.VarChar(50), auditorId)
        .input('SampleSize', sql.Int(), sampleSize)
        .execute('SaveEvaluationEfectivitySample')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::SaveEvaluationEfectivitySample] Success request');
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::SaveEvaluationEfectivitySample] ' + errorMsg + '|' + efectivityPlanId);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationEfectivitySample = SaveEvaluationEfectivitySample;
function GetEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlan')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlan] Results from SP: ' + recordsets.length);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlan = GetEvaluationPlan;
function GetAuditorsEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('idEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('GetAuditorsEvaluationPlan')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetAuditorsEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAuditorsEvaluationPlan = GetAuditorsEvaluationPlan;
function DeleteAuditorEvaluationPlan(instance, idEvaluationPlan) {
    logger.info('Eliminando asignaciones del plan de ev. ' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteAuditorEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlan = DeleteAuditorEvaluationPlan;
function DeleteAuditorEvaluationPlanByInteraction(vcc, idEvaluationPlan, idInteraction, interactionType, isDraft) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('IdInteraction', sql.VarChar(250), idInteraction)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('IsDraft', sql.Bit(), isDraft)
        .execute('DeleteAuditorEvaluationPlanByInteraction')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAuditorEvaluationPlanByInteraction = DeleteAuditorEvaluationPlanByInteraction;
function SaveEvaluationPlanCompleted(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('SaveEvaluationPlanCompleted')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationPlanCompleted = SaveEvaluationPlanCompleted;
function SaveAuditorEvPlanResult(instance, idEvaluationPlan, idAuditor, idInteraction, interactionType, idAgent, score) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('idAuditor', sql.VarChar(50), idAuditor)
        .input('idInteraction', sql.VarChar(50), idInteraction)
        .input('interactionType', sql.VarChar(50), interactionType)
        .input('idAgent', sql.VarChar(50), idAgent)
        .input('score', sql.Numeric(5, 2), score)
        .execute('SaveAuditorEvPlanResult')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAuditorEvPlanResult = SaveAuditorEvPlanResult;
function SaveInteractionEvaluationPlanSample(vcc, evaluationPlanId, evaluatePercentage) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('EvaluatePercentage', sql.Decimal(18, 2), evaluatePercentage)
        .execute('SaveInteractionEvaluationPlanSample')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveInteractionEvaluationPlanSample = SaveInteractionEvaluationPlanSample;
function DeleteEvaluationPlan(instance, idEvaluationPlan) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('DeleteEvaluationPlan')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationPlan = DeleteEvaluationPlan;
function GetEvaluationPlanTask(instance, idEvaluationPlan) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Calling SP for vcc|evid: ' + instance + '|' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationPlan)
        .execute('GetEvaluationPlanTask')
        .then(function (recordsets) {
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Received result from SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTask] Results from SP: ' + recordsets.length);
        var evaluationPlan = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationPlan);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationPlanMSSql::GetEvaluationPlanTask] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanTask = GetEvaluationPlanTask;
function GetEvaluationPlanAbilityGenericQueryTask(vcc, evaluationPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanAbilityGenericQueryTask')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanAbilityGenericQueryTask = GetEvaluationPlanAbilityGenericQueryTask;
function GetEvaluationPlanCognitiveInteractionTask(vcc, evaluationPlanId) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanCognitiveInteractionTask] getting vcc:', vcc, 'evaluationPlanId:', evaluationPlanId);
    var genericResult = {};
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanCognitiveInteractionTask')
        .then(function (recordsets) {
        var callCognitiveInteractions = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var asyncCognitiveInteractions = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
        callCognitiveInteractions = callCognitiveInteractions ? callCognitiveInteractions : [];
        asyncCognitiveInteractions = asyncCognitiveInteractions ? asyncCognitiveInteractions : [];
        genericResult.status = true;
        genericResult.description = 'OK';
        genericResult.data = callCognitiveInteractions.concat(asyncCognitiveInteractions);
        return Promise.resolve(genericResult);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanCognitiveInteractionTask = GetEvaluationPlanCognitiveInteractionTask;
function GetEvaluationPlanTipificationInteractionTask(vcc, evaluationPlanId) {
    logger.info('[EvaluationPlanMSSql::GetEvaluationPlanTipificationInteractionTask] getting vcc:', vcc, 'evaluationPlanId:', evaluationPlanId);
    var genericResult = {};
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationPlanTipificationInteractionTask')
        .then(function (recordsets) {
        var callCognitiveInteractions = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var asyncCognitiveInteractions = (recordsets && recordsets.length > 1 ? recordsets[1] : null);
        callCognitiveInteractions = callCognitiveInteractions ? callCognitiveInteractions : [];
        asyncCognitiveInteractions = asyncCognitiveInteractions ? asyncCognitiveInteractions : [];
        genericResult.status = true;
        genericResult.description = 'OK';
        genericResult.data = callCognitiveInteractions.concat(asyncCognitiveInteractions);
        return Promise.resolve(genericResult);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationPlanTipificationInteractionTask = GetEvaluationPlanTipificationInteractionTask;
function CleanFailedEvaluationPlanData(VCC, idEvaluationPlan) {
    logger.info('Limpiando datos fallidos del plan de evaluacion: ' + idEvaluationPlan);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), VCC)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .execute('CleanFailedEvaluationPlanData')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CleanFailedEvaluationPlanData = CleanFailedEvaluationPlanData;
function GetFiltersFromEvaluation(vcc, userId, campaigns, searchType, efectivityMode) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('UserId', sql.VarChar(50), userId)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('SearchType', sql.VarChar(50), searchType)
        .input('EfectivityMode', sql.Bit(), efectivityMode)
        .execute('GetFiltersFromEvaluation')
        .then(function (recordsets) {
        var campaignsRecords = recordsets && recordsets.length > 0 ? recordsets[0] : null;
        var agentsRecords = recordsets && recordsets.length > 0 ? recordsets[1] : null;
        var dispositionCodesRecords = recordsets && recordsets.length > 0 ? recordsets[2] : null;
        var interactionTypesRecords = recordsets && recordsets.length > 0 ? recordsets[3] : null;
        return Promise.resolve({
            agents: agentsRecords,
            campaigns: campaignsRecords,
            dispositionCodes: dispositionCodesRecords,
            interactionTypes: interactionTypesRecords
        });
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetFiltersFromEvaluation = GetFiltersFromEvaluation;
function GetEvaluationResultEfectivitySummary(vcc, efectivityPlanId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EfectivityPlanId', sql.VarChar(sql.MAX), efectivityPlanId)
        .execute('GetEvaluationResultEfectivitySummary')
        .then(function (recordsets) {
        var recorset = recordsets && recordsets.length > 0 ? recordsets[0] : null;
        return Promise.resolve(recorset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationResultEfectivitySummary = GetEvaluationResultEfectivitySummary;
function UpdateStatusEvaluationPlan(vcc, idEvaluationPlan, status, statusDescription) {
    if (statusDescription === void 0) { statusDescription = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('IdEvaluationPlan', sql.VarChar(50), idEvaluationPlan)
        .input('Status', sql.VarChar(50), status)
        .input('StatusDescription', sql.VarChar(50), statusDescription)
        .execute('UpdateStatusEvaluationPlan')
        .then(function (recordsets) { return (0, response_1.responseSaveOrDelete)(recordsets); })
        .catch(function (err) { return (0, response_1.responseError)(err); });
}
exports.UpdateStatusEvaluationPlan = UpdateStatusEvaluationPlan;
