"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.responseSaveOrDelete = exports.responseObjectGet = exports.responseArrayGet = exports.responseError = void 0;
var log4js = require("log4js");
var logger = log4js.getLogger('Sql');
var responseError = function (err) {
    var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
    logger.error(errorMsg);
    return Promise.reject(err);
};
exports.responseError = responseError;
var responseArrayGet = function (recordsets) {
    var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
    return Promise.resolve(recordset);
};
exports.responseArrayGet = responseArrayGet;
var responseObjectGet = function (recordsets) {
    var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
    var data = (recordset && recordset.length > 0 ? recordset[0] : null);
    return Promise.resolve(data);
};
exports.responseObjectGet = responseObjectGet;
var responseSaveOrDelete = function (recordsets) {
    var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
    var output = (recordset && recordset.length > 0 ? recordset[0] : null);
    return Promise.resolve(output && output.result === 1);
};
exports.responseSaveOrDelete = responseSaveOrDelete;
