"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CassandralInit = void 0;
var log4js = require("log4js");
var cassandra = require('cassandra-client').Connection;
var integration_cassandra_1 = require("./cassandra/integration.cassandra");
var logger = log4js.getLogger('Cassandra');
var integration_config_1 = require("../config/integration.config");
function CassandralInit(app) {
    return new Promise(function (resolve, reject) {
        logger.info('Iniciando conexión a base de datos cassandra \'' + integration_config_1.IP_I6 + '\'');
        var cassandraConn = new cassandra({ host: integration_config_1.IP_I6, port: integration_config_1.PORT, keyspace: 'Agent', timeout: 14000 });
        cassandraConn.connect(function (err, con) {
            if (err) {
                var errMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
                logger.error('No se pudo establecer conexion a base de datos cassandra: ' + errMsg);
                reject(err);
            }
            else {
                logger.info('Conexión a base de datos cassandra establecida');
                resolve(true);
            }
        });
        app.set('cassandraConn', cassandraConn);
        (0, integration_cassandra_1.IntegrationCassandraSql)(app);
    });
}
exports.CassandralInit = CassandralInit;
