"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloseI6InteractionAsyncInteraction = exports.DeleteI6InteractionText = exports.SaveI6InteractionAsyncInteraction = exports.CloseI6InteractionAudio = exports.DeleteI6InteractionAudio = exports.SaveI6InteractionAudio = exports.GetI6InteractionMessages = exports.GetI6InteractionAudios = exports.GetInteractionQueryResults = exports.GetInteractionTranscription = exports.GetAsyncBillingInteractions = exports.BulkBillingInteractions = exports.GetI6TextInteractions = exports.GetI6AlreadyRegisteredTextInteractions = exports.GetI6AlreadyRegisteredCallInteractions = exports.GetI6CallInteractions = exports.GetAllegroInteractions = exports.GetInteractions = exports.GetEvaluationTypesInteraction = exports.GetEvaluatedInteractions = exports.GetEvaluatedInteractionsByCampaignsAuditorsAndAgents = exports.GetEvaluatedInteractionsByAuditor = exports.GetNotEvaluatedInteractionsEfectivityAuditor = exports.GetNotEvaluatedInteractionsAuditor = exports.InteractionMSSql = void 0;
var log4js = require("log4js");
var moment = require("moment");
var sql = require('mssql');
var interaction_model_1 = require("../../models/interaction.model");
var logger = log4js.getLogger('Sql');
var sqlConn;
function InteractionMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.InteractionMSSql = InteractionMSSql;
function GetNotEvaluatedInteractionsAuditor(instance, userId, campaigns, agents, evaluationPlans, interactionTypes, interactionResults, dateEvaluationPlanFin, evaluationStatus, interactionIds, contactAddress, dateIni, dateFin, auditors) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (contactAddress === void 0) { contactAddress = ''; }
    logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] Calling SP GetNotEvaluatedInteractionsAuditor for VCC: ' + instance);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(50), userId)
        .input('IdCampaigns', sql.VarChar(sql.MAX), campaigns)
        .input('IdAgents', sql.VarChar(sql.MAX), agents)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('InteractionTypes', sql.VarChar(100), interactionTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationPlanDateTo', sql.VarChar(50), dateEvaluationPlanFin)
        .input('EvaluationStatus', sql.Bit(), evaluationStatus)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('EvaluationDateFrom', sql.VarChar(300), dateIni)
        .input('EvaluationDateTo', sql.VarChar(300), dateFin)
        .input('IdAuditors', sql.VarChar(sql.MAX), auditors)
        .execute('GetNotEvaluatedInteractionsAuditor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] Received result from SP GetNotEvaluatedInteractionsAuditor: ' + recordsets.length);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNotEvaluatedInteractionsAuditor = GetNotEvaluatedInteractionsAuditor;
function GetNotEvaluatedInteractionsEfectivityAuditor(instance, userId, campaigns, agents, evaluationPlans, interactionTypes, interactionResults, dateEvaluationPlanFin, evaluationStatus, interactionIds, contactAddress, efectivityPlans, dateIni, dateFin) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (contactAddress === void 0) { contactAddress = ''; }
    if (efectivityPlans === void 0) { efectivityPlans = ''; }
    logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] Calling SP GetNotEvaluatedInteractionsEfectivityAuditor for VCC: ' + instance);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(50), userId)
        .input('IdCampaigns', sql.VarChar(sql.MAX), campaigns)
        .input('IdAgents', sql.VarChar(sql.MAX), agents)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('InteractionTypes', sql.VarChar(100), interactionTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationPlanDateTo', sql.VarChar(50), dateEvaluationPlanFin)
        .input('EvaluationStatus', sql.Bit(), evaluationStatus)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('EfectivityPlans', sql.VarChar(sql.MAX), efectivityPlans)
        .input('EvaluationDateFrom', sql.VarChar(300), dateIni)
        .input('EvaluationDateTo', sql.VarChar(300), dateFin)
        .execute('GetNotEvaluatedInteractionsEfectivityAuditor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] Received result from SP GetNotEvaluatedInteractionsEfectivityAuditor: ' + recordsets.length);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNotEvaluatedInteractionsEfectivityAuditor = GetNotEvaluatedInteractionsEfectivityAuditor;
function GetEvaluatedInteractionsByAuditor(instance, auditorIds, agentIds, campaignIds, evaluationPlanIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, interactionTags, interactionFormats, interactionIds) {
    if (interactionIds === void 0) { interactionIds = ''; }
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] Calling GetEvaluatedInteractionsByAuditor SP');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('IdEvaluationPlan', sql.VarChar(sql.MAX), evaluationPlanIds)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .execute('GetEvaluatedInteractionsByAuditor')
        .then(function (recordsets) {
        logger.info('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] Received resulto from GetEvaluatedInteractionsByAuditor SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractionsByAuditor = GetEvaluatedInteractionsByAuditor;
function GetEvaluatedInteractionsByCampaignsAuditorsAndAgents(instance, auditorIds, agentIds, campaignIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, evaluationTypes, interactionTags, interactionFormats, contactAddress) {
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Received Instance: ' + instance);
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Calling SP GetEvaluatedInteractionsByCampaignsAuditorsAndAgents');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('EvaluationDateFrom', sql.VarChar(sql.MAX), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(sql.MAX), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationTypes', sql.VarChar(sql.MAX), evaluationTypes)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetEvaluatedInteractionsByCampaignsAuditorsAndAgents')
        .then(function (recordsets) {
        logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Received result from GetEvaluatedInteractionsByCampaignsAuditorsAndAgents SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractionsByCampaignsAuditorsAndAgents = GetEvaluatedInteractionsByCampaignsAuditorsAndAgents;
function GetEvaluatedInteractions(instance, auditorIds, agentIds, campaignIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, interactionTags, interactionFormats) {
    logger.info('[InteractionMSSql::GetEvaluatedInteractions] Received Instance: ' + instance);
    logger.info('[InteractionMSSql::GetEvaluatedInteractions] Calling SP GetEvaluatedInteractions');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .execute('GetEvaluatedInteractions')
        .then(function (recordsets) {
        logger.info('[InteractionMSSql::GetEvaluatedInteractions] Received result from GetEvaluatedInteractions SP');
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractions = GetEvaluatedInteractions;
function GetEvaluationTypesInteraction(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationTypesInteraction')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationTypesInteraction = GetEvaluationTypesInteraction;
function GetInteractions(instance, limit, agents, campaigns, dateIni, dateFin, minDuration, maxDuration, origins, hourIni, hourFin, tags, evaluationTypes, results, formats, interactionIds, evaluated, withSectionPart) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (evaluated === void 0) { evaluated = ''; }
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAgent', sql.VarChar(sql.MAX), agents)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationDateFrom', sql.VarChar(50), dateIni)
        .input('EvaluationDateTo', sql.VarChar(50), dateFin)
        .input('EvaluationHourFrom', sql.VarChar(50), hourIni)
        .input('EvaluationHourTo', sql.VarChar(50), hourFin)
        .input('InteractionMinDuration', sql.Int, minDuration)
        .input('InteractionMaxDuration', sql.Int, maxDuration)
        .input('InteractionOrigins', sql.VarChar(50), origins)
        .input('InteractionsLimit', sql.Int, limit)
        .input('InteractionTags', sql.VarChar(sql.MAX), tags)
        .input('InteractionEvaluationTypes', sql.VarChar(sql.MAX), evaluationTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), results)
        .input('InteractionFormats', sql.VarChar(50), formats)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('InteractionWithSectionPart', sql.Bit, withSectionPart)
        .execute('GetInteractionsSearch')
        .then(function (recordsets) {
        var recorddata = (recordsets && recordsets.length > 0 ? recordsets[0] : "No result");
        logger.info('[InteractionMSSql::GetInteractions] Interaccions search result: ', recordsets);
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[1] : null);
        var result = new interaction_model_1.InteractionView;
        result.interactionType = 'CALL';
        result.totalTime = recorddata[0].totalTime;
        result.totalRecords = recorddata[0].totalRecords;
        result.interactions = recordset;
        return Promise.resolve(result);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractions = GetInteractions;
function GetAllegroInteractions(ip, vcc, startDate, endDate, startHour, endHour, campaign, agent, resultCode, type, origin, minDuration, maxDuration, format, interactionIds, evaluated, resultType, contactAddress, limitIntByAgent) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (evaluated === void 0) { evaluated = ''; }
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaign', sql.VarChar(sql.MAX), campaign)
        .input('Agent', sql.VarChar(sql.MAX), agent)
        .input('ResultCode', sql.VarChar(sql.MAX), resultCode)
        .input('Type', sql.Int, type)
        .input('Origin', sql.VarChar(sql.MAX), origin)
        .input('MinDuration', sql.Int, minDuration)
        .input('MaxDuration', sql.Int, maxDuration)
        .input('Format', sql.VarChar(50), format)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('LimitIntByAgent', sql.Int, limitIntByAgent)
        .execute('GetAllegroInteractions')
        .then(function (recordsets) {
        var summary = (recordsets && recordsets.length > 0 ? recordsets[0] : "No result");
        var detail = [];
        var filtersAgent = [];
        if (resultType === 'DETAILED') {
            detail = (recordsets && recordsets.length > 1 ? recordsets[1] : []);
        }
        if (resultType === 'SUMMARIZED') {
            filtersAgent = (recordsets && recordsets.length > 1 ? recordsets[1] : []);
        }
        var result = {};
        var recordset = (summary && summary.length > 0 ? summary[0] : null);
        result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : 'CALL';
        result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
        result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
        result.totalInteractionTime = recordset && recordset.attentionTime ? recordset.attentionTime : 0;
        result.filtersAgent = filtersAgent.map(function (fa) { return fa.agent; });
        if (resultType === 'SUMMARIZED') {
        }
        else if (resultType === 'DETAILED') {
            result.interactions = detail ? detail : [];
        }
        return Promise.resolve(result);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetAllegroInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAllegroInteractions = GetAllegroInteractions;
;
function GetI6CallInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, minDuration, maxDuration, interactionIds, evaluated, uniqueIds, resultType, contactAddress) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (evaluated === void 0) { evaluated = ''; }
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input('MinDuration', sql.Int, minDuration)
        .input('MaxDuration', sql.Int, maxDuration)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('UniqueIds', sql.Bit, uniqueIds)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetI6SyncInteractions')
        .then(function (recordsets) {
        var recorddata = (recordsets && recordsets.length > 0 ? recordsets[0] : []);
        var result = {};
        if (resultType === 'SUMMARIZED') {
            var recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
            result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : interactionType;
            result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
            result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
            result.totalInteractionTime = recordset && recordset.attentionTime ? recordset.attentionTime : 0;
        }
        else if (resultType === 'DETAILED') {
            result.interactionType = interactionType;
            result.totalInteractions = recorddata.length ?
                recorddata.map(function (item) { return item.InteractionId; }).filter(function (value, index, self) { return self.indexOf(value) === index; }).length
                :
                    0;
            result.totalInteractionDetails = recorddata.length ? recorddata.length : 0;
            result.interactions = [];
            recorddata.map(function (rd) {
                if (rd.TotalParts === null || rd.TotalParts === 0)
                    rd.TotalParts = 1;
                for (var i = 1; i <= rd.TotalParts; i++) {
                    var currentItem = JSON.parse(JSON.stringify(rd));
                    currentItem.ID = currentItem.InteractionId + '_0_' + i;
                    currentItem.Part = i;
                    result.interactions.push(currentItem);
                }
            });
        }
        return Promise.resolve(result);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetI6AsyncInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6CallInteractions = GetI6CallInteractions;
function GetI6AlreadyRegisteredCallInteractions(vcc, interactions) {
    var table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetI6AlreadyRegisteredInteractionsFromTemporaryTable(table, vcc, 'Call');
}
exports.GetI6AlreadyRegisteredCallInteractions = GetI6AlreadyRegisteredCallInteractions;
function GetI6AlreadyRegisteredTextInteractions(vcc, interactions) {
    var table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetI6AlreadyRegisteredInteractionsFromTemporaryTable(table, vcc, 'Text');
}
exports.GetI6AlreadyRegisteredTextInteractions = GetI6AlreadyRegisteredTextInteractions;
function GetI6AlreadyRegisteredInteractionsFromTemporaryTable(temporaryTable, vcc, target) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Creating transaction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(temporaryTable)
            .then(function (rowCount) {
            logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Inserted ' + rowCount + ' records to temporary Table');
            return Promise.resolve(true);
        })
            .catch(function (err) {
            logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Error on bulk: ' + err.message);
            throw err;
        });
    })
        .then(function (result) {
        return request
            .input('VCC', sql.VarChar(50), vcc)
            .execute("GetI6AlreadyRegistered".concat(target, "Interactions"))
            .then(function (recordsets) {
            logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Ejecucion Correcta');
            var results = (recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : [];
            return Promise.resolve(results);
        })
            .catch(function (err) {
            logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Al ejecutar el procedure: ' + err.message);
            return Promise.reject(err);
        });
    })
        .then(function (result) {
        logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Saving transaction');
        transaction.commit();
        return Promise.resolve(result);
    })
        .catch(function (err) {
        logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
function GetI6TextInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, interactionIds, evaluated, uniqueIds, resultType, contactAddress) {
    if (interactionIds === void 0) { interactionIds = ''; }
    if (evaluated === void 0) { evaluated = ''; }
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .input("Evaluated", sql.VarChar(sql.MAX), evaluated)
        .input('UniqueIds', sql.Bit, uniqueIds)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetI6AsyncInteractions')
        .then(function (recordsets) {
        var recorddata = (recordsets && recordsets.length > 0 ? recordsets[0] : "No result");
        var result = new interaction_model_1.AsyncInteractionView;
        if (resultType === 'SUMMARIZED') {
            var recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
            result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : interactionType;
            result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
            result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
        }
        else if (resultType === 'DETAILED') {
            result.interactionType = interactionType;
            result.totalInteractions = recorddata.length ?
                recorddata.map(function (item) { return item.id; }).filter(function (value, index, self) { return self.indexOf(value) === index; }).length
                :
                    0;
            result.totalInteractionDetails = recorddata.length ? recorddata.length : 0;
            result.interactions = recorddata ? recorddata : [];
        }
        return Promise.resolve(result);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetI6AsyncInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6TextInteractions = GetI6TextInteractions;
function BulkBillingInteractions(vcc, modelSecondsPerRequest, modelCharsPerPhrase, channel, interactions, retranscription) {
    var table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetBillingInteractionsFromTemporaryTable(table, vcc, modelSecondsPerRequest, modelCharsPerPhrase, channel, retranscription);
}
exports.BulkBillingInteractions = BulkBillingInteractions;
function SetInteractionsToTemporaryTable(vcc, data) {
    var table = new sql.Table('#InteractionsTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(250), { nullable: true });
    table.columns.add('InteractionId', sql.VarChar(250), { nullable: true });
    table.columns.add('Section', sql.Int, { nullable: true });
    table.columns.add('Part', sql.Int, { nullable: true });
    table.columns.add('Folder', sql.VarChar(25), { nullable: true });
    table.columns.add('Channel', sql.VarChar(25), { nullable: true });
    table.columns.add('Campaign', sql.VarChar(50), { nullable: true });
    table.columns.add('EndDate', sql.DateTime, { nullable: true });
    table.columns.add('AttentionTime', sql.Int, { nullable: true });
    table.columns.add('RawChar', sql.Int, { nullable: true });
    table.columns.add('Agent', sql.VarChar(50), { nullable: true });
    data.forEach(function (d) {
        table.rows.add(vcc, d.ID, d.InteractionId ? d.InteractionId : null, d.Section ? d.Section : 0, d.Part ? d.Part : 0, d.folder ? d.folder : null, d.InteractionType ? d.InteractionType : d.channel ? d.channel : null, d.Campaign ? d.Campaign : null, d.EndDate ? moment(d.EndDate + 'Z').toDate() : null, d.AttentionTime ? d.AttentionTime : null, d.rawChar ? d.rawChar : null, d.agent ? d.agent : d.lastTakedAgent ? d.lastTakedAgent : null);
    });
    return table;
}
function GetBillingInteractionsFromTemporaryTable(temporaryTable, vcc, secondsPerRequest, charsPerPhrase, channel, retranscription) {
    var transaction = new sql.Transaction(sqlConn);
    var request;
    return transaction.begin()
        .then(function (result) {
        logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Creating transaction');
        return new sql.Request(transaction);
    })
        .then(function (result) {
        request = result;
        return request.bulk(temporaryTable)
            .then(function (rowCount) {
            logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Inserted ' + rowCount + ' records to temporary Table');
            return true;
        })
            .catch(function (err) {
            logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Error on bulk: ' + err.message);
            throw err;
        });
    })
        .then(function (result) {
        return request
            .input('VCC', sql.VarChar(50), vcc)
            .input('SecondsPerRequest', sql.Decimal(18, 5), secondsPerRequest)
            .input('CharsPerPhrase', sql.Decimal(18, 5), charsPerPhrase)
            .input('Channel', sql.VarChar(25), channel)
            .input('Retranscription', sql.Int, retranscription)
            .execute('GetBillingInteractions')
            .then(function (recordsets) {
            logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Ejecucion Correcta');
            var results = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
            var promiseArray = [];
            promiseArray.push(Promise.resolve(results && results.length > 0 ? results[0] : null));
            promiseArray.push(transaction.commit());
            return Promise.all(promiseArray);
        })
            .catch(function (err) {
            logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Al ejecutar el procedure: ' + err.message);
            return Promise.reject(err);
        });
    })
        .then(function (result) {
        logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Saving transaction');
        return Promise.resolve(result[0]);
    })
        .catch(function (err) {
        logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
function GetAsyncBillingInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, interactionIds, cognitiveServiceCharsPerPhrase) {
    if (interactionIds === void 0) { interactionIds = ''; }
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .input('CharsPerPhrase', sql.Int, cognitiveServiceCharsPerPhrase)
        .execute('GetAsyncBillingInteractions')
        .then(function (recordsets) {
        var recorddata = (recordsets && recordsets.length > 0 ? recordsets[0] : "No result");
        var recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetAsyncBillingInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAsyncBillingInteractions = GetAsyncBillingInteractions;
function GetInteractionTranscription(vcc, evaluationPlanId, processId, interactionType, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('InteractionType', sql.VarChar(250), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetInteractionTranscription')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionTranscription = GetInteractionTranscription;
function GetInteractionQueryResults(vcc, transactionType, transactionId, interactionType, interactionId, campaign, folder) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TransactionType', sql.VarChar(50), transactionType)
        .input('TransactionId', sql.VarChar(50), transactionId)
        .input('InteractionType', sql.VarChar(10), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Folder', sql.VarChar(50), folder)
        .execute('GetInteractionQueryResults')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        recordset.map(function (r) {
            if (r.queryData) {
                r.queryData = JSON.parse(r.queryData);
                r.details = JSON.parse(r.details);
            }
        });
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionQueryResults = GetInteractionQueryResults;
function GetI6InteractionAudios(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetI6InteractionAudios')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6InteractionAudios = GetI6InteractionAudios;
function GetI6InteractionMessages(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetI6InteractionMessages')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6InteractionMessages = GetI6InteractionMessages;
function SaveI6InteractionAudio(vcc, interactionId, oldSection, oldPart, newSection, newPart, startDate, endDate, durationTime, agentId, format, campaign, origin, category1, category2, category3, description, filename, contactId, contactName, contactAddress, processId, ender, ticket) {
    if (startDate === void 0) { startDate = null; }
    if (endDate === void 0) { endDate = null; }
    if (durationTime === void 0) { durationTime = null; }
    if (filename === void 0) { filename = null; }
    if (processId === void 0) { processId = null; }
    if (ender === void 0) { ender = null; }
    if (ticket === void 0) { ticket = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('OldSection', sql.Int, oldSection)
        .input('OldPart', sql.Int, oldPart)
        .input('NewSection', sql.Int, newSection)
        .input('NewPart', sql.Int, newPart)
        .input('StartDate', sql.DateTime(), startDate)
        .input('EndDate', sql.DateTime(), endDate)
        .input('DurationTime', sql.Int, durationTime)
        .input('AgentId', sql.VarChar(50), agentId)
        .input('Format', sql.VarChar(50), format)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Origin', sql.VarChar(25), origin)
        .input('Category1', sql.VarChar(100), category1)
        .input('Category2', sql.VarChar(100), category2)
        .input('Category3', sql.VarChar(100), category3)
        .input('Description', sql.VarChar(100), description)
        .input('Filename', sql.VarChar(200), filename)
        .input('ContactId', sql.VarChar(50), contactId)
        .input('ContactName', sql.VarChar(300), contactName)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Ender', sql.VarChar(300), ender)
        .input('Ticket', sql.VarChar(250), ticket)
        .execute('SaveI6InteractionAudio')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveI6InteractionAudio = SaveI6InteractionAudio;
function DeleteI6InteractionAudio(vcc, interactionId, section, part) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Section', sql.Int, section)
        .input('Part', sql.Int, part)
        .execute('DeleteI6InteractionAudio')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteI6InteractionAudio = DeleteI6InteractionAudio;
function CloseI6InteractionAudio(vcc, interactionId, succed, errorMessage) {
    if (vcc === void 0) { vcc = null; }
    if (interactionId === void 0) { interactionId = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Succed', sql.Bit, succed)
        .input('ErrorMessage', sql.VarChar(50), errorMessage)
        .execute('CloseI6InteractionAudio')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CloseI6InteractionAudio = CloseI6InteractionAudio;
function SaveI6InteractionAsyncInteraction(vcc, interactionId, channel, folder, startDate, endDate, durationTime, agentId, campaign, account, origin, dispositionTreePath, dispositionCode, exportedContent, contactId, contactName, contactAddress, totalMessages, processId, ender, ticket) {
    if (vcc === void 0) { vcc = null; }
    if (interactionId === void 0) { interactionId = null; }
    if (channel === void 0) { channel = null; }
    if (folder === void 0) { folder = null; }
    if (startDate === void 0) { startDate = null; }
    if (endDate === void 0) { endDate = null; }
    if (durationTime === void 0) { durationTime = null; }
    if (agentId === void 0) { agentId = null; }
    if (campaign === void 0) { campaign = null; }
    if (account === void 0) { account = null; }
    if (origin === void 0) { origin = null; }
    if (dispositionTreePath === void 0) { dispositionTreePath = null; }
    if (dispositionCode === void 0) { dispositionCode = null; }
    if (exportedContent === void 0) { exportedContent = null; }
    if (contactId === void 0) { contactId = null; }
    if (contactName === void 0) { contactName = null; }
    if (contactAddress === void 0) { contactAddress = null; }
    if (totalMessages === void 0) { totalMessages = null; }
    if (processId === void 0) { processId = null; }
    if (ender === void 0) { ender = null; }
    if (ticket === void 0) { ticket = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.VarChar(50), folder)
        .input('Channel', sql.VarChar(25), channel)
        .input('StartDate', sql.DateTime(), startDate)
        .input('EndDate', sql.DateTime(), endDate)
        .input('DurationTime', sql.Int, durationTime)
        .input('AgentId', sql.VarChar(50), agentId)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Account', sql.VarChar(50), account)
        .input('Origin', sql.VarChar(25), origin)
        .input('DispositionTreePath', sql.VarChar(100), dispositionTreePath)
        .input('DispositionCode', sql.VarChar(100), dispositionCode)
        .input('ExportedContent', sql.VarChar(250), exportedContent)
        .input('ContactId', sql.VarChar(50), contactId)
        .input('ContactName', sql.VarChar(300), contactName)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('TotalMessages', sql.Int, totalMessages)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Ender', sql.VarChar(300), ender)
        .input('Ticket', sql.VarChar(300), ticket)
        .execute('SaveI6InteractionAsyncInteraction')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveI6InteractionAsyncInteraction = SaveI6InteractionAsyncInteraction;
function DeleteI6InteractionText(vcc, interactionId, folder) {
    if (vcc === void 0) { vcc = null; }
    if (interactionId === void 0) { interactionId = null; }
    if (folder === void 0) { folder = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.Int, folder)
        .execute('DeleteI6InteractionText')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteI6InteractionText = DeleteI6InteractionText;
function CloseI6InteractionAsyncInteraction(vcc, interactionId, folder, channel, succed, errorMessage) {
    if (vcc === void 0) { vcc = null; }
    if (interactionId === void 0) { interactionId = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.VarChar(50), folder)
        .input('Channel', sql.VarChar(25), channel)
        .input('Succed', sql.Bit, succed)
        .input('ErrorMessage', sql.VarChar(50), errorMessage)
        .execute('CloseI6InteractionAsyncInteraction')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CloseI6InteractionAsyncInteraction = CloseI6InteractionAsyncInteraction;
