"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteWorkGroupSupervisor = exports.GetWorkGroupsFromSupervisorEP = exports.GetWorkGroupSupervisor = exports.SaveWorkGroupSupervisor = exports.GetWorkGroupsSupervisor = exports.WorkGroupSupervisorMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function WorkGroupSupervisorMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.WorkGroupSupervisorMSSql = WorkGroupSupervisorMSSql;
function GetWorkGroupsSupervisor(vcc, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetWorkGroupsSupervisor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWorkGroupsSupervisor = GetWorkGroupsSupervisor;
function SaveWorkGroupSupervisor(vcc, userId, nowUtc, workGroupSupervisor) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Description', sql.VarChar(50), workGroupSupervisor.description)
        .input('SupervisorId', sql.VarChar(250), workGroupSupervisor.supervisorId)
        .input('CampaignId', sql.VarChar(250), workGroupSupervisor.campaignId)
        .input('AgentId', sql.VarChar(250), workGroupSupervisor.agentId)
        .input('CreatedDate', sql.DateTime, nowUtc)
        .input('CreatedByUserId', sql.VarChar(50), userId)
        .input('LastModifiedDate', sql.DateTime, nowUtc)
        .input('LastModifiedByUserId', sql.VarChar(50), userId)
        .input('isHistoric', sql.Bit, workGroupSupervisor.isHistoric)
        .execute('SaveWorkGroupSupervisor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveWorkGroupSupervisor = SaveWorkGroupSupervisor;
function GetWorkGroupSupervisor(vcc, supervisorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SupervisorId', sql.VarChar(250), supervisorId)
        .execute('GetWorkGroupSupervisor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWorkGroupSupervisor = GetWorkGroupSupervisor;
function GetWorkGroupsFromSupervisorEP(vcc, campaignIds) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('CampaignIds', sql.VarChar(sql.MAX), campaignIds)
        .execute('GetWorkGroupsFromSupervisorEP')
        .then(function (recordsets) {
        var workgroupsupervisor = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(workgroupsupervisor);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWorkGroupsFromSupervisorEP = GetWorkGroupsFromSupervisorEP;
function DeleteWorkGroupSupervisor(vcc, description, supervisorId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Description', sql.VarChar(50), description)
        .input('SupervisorId', sql.VarChar(250), supervisorId)
        .execute('DeleteWorkGroupSupervisor')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteWorkGroupSupervisor = DeleteWorkGroupSupervisor;
