"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendIOEvents = void 0;
var server_config_1 = require("../config/server.config");
var log4js = require("log4js");
var promises_shared_1 = require("../shared/promises.shared");
var request_shared_1 = require("../shared/request.shared");
var logger = log4js.getLogger('IO');
var fs = require('fs');
function SendIOEvents(events) {
    return (0, promises_shared_1.DummyPromise)().then(function (_) {
        return (0, request_shared_1.SimplePostRequest)({
            uri: "https://localhost/io/send-events",
            body: JSON.stringify(events),
            headers: { 'Content-Type': 'application/json' },
            httpAgent: {
                key: fs.readFileSync(server_config_1.HTTPS_KEY),
                cert: fs.readFileSync(server_config_1.HTTPS_CERT),
                rejectUnauthorized: false,
                keepAlive: true
            },
            httpsAgent: {
                key: fs.readFileSync(server_config_1.HTTPS_KEY),
                cert: fs.readFileSync(server_config_1.HTTPS_CERT),
                rejectUnauthorized: false,
                keepAlive: true
            },
            timeout: 15000,
            retryProtocol: false
        });
    }).then(function (result) {
        return result.data && result.data.status;
    }).catch(function (err) {
        logger.error("[io.requests::SendIOEvents] Error:", err);
        return false;
    });
}
exports.SendIOEvents = SendIOEvents;
