"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrantAccess = void 0;
var log4js = require("log4js");
var promises_shared_1 = require("../shared/promises.shared");
var logger = log4js.getLogger('ServerScripts');
function GrantAccess(req, res, next) {
    if (!req.url.match('^\/(api|builder)\/'))
        return next();
    var vcc = res.locals.vcc;
    var userId = res.locals.userId;
    var role = res.locals.userRole;
    var urlPath = req.path;
    if (urlPath.startsWith('/'))
        urlPath = urlPath.slice(1);
    if (urlPath.indexOf('api/public') > -1)
        return next();
    (0, promises_shared_1.DummyPromise)()
        .then(function (result) {
        if (HasPermissionForURL(role, urlPath)) {
            return next();
        }
        else {
            logger.warn('Intento de acceso sin permisos a la api: (instancia) ' + vcc + ' (user) ' + userId + ' (url) ' + urlPath);
            res.sendStatus(403);
        }
    }).catch(function (err) {
        logger.error('Error al procesar validar permisos de acceso: ' + err);
    });
}
exports.GrantAccess = GrantAccess;
function HasPermissionForURL(role, url) {
    var hasPermission = !!(role.routePermissions && role.routePermissions.find(function (routePermission) {
        return (routePermission.level === 'api' && routePermission.route &&
            (routePermission.route === url || (routePermission.route.endsWith('/') && url.startsWith(routePermission.route))));
    }));
    return hasPermission;
}
