"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsS3Implementation = void 0;
var client_s3_1 = require("@aws-sdk/client-s3");
var log4js = require("log4js");
var logger = log4js.getLogger('Task');
var AwsS3Implementation = (function () {
    function AwsS3Implementation(region, accessKeyId, secretAccessKey, defaultBucket) {
        this.s3Client = null;
        this.defaultBucket = null;
        this.s3Client = new client_s3_1.S3Client({
            region: region,
            credentials: {
                accessKeyId: accessKeyId,
                secretAccessKey: secretAccessKey
            }
        });
        this.defaultBucket = defaultBucket;
    }
    AwsS3Implementation.prototype.DownloadFile = function (path) {
        var _this = this;
        var promiseAws = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.s3Client.send(new client_s3_1.GetObjectCommand({
                            Bucket: this.defaultBucket,
                            Key: this.CleanPath(path)
                        }))];
                    case 1: return [2, (_a.sent()).Body];
                }
            });
        }); };
        return promiseAws()
            .then(function (result) {
            logger.info('[AwsS3Implementation::DownloadFile] Succed');
            return Promise.resolve(result);
        })
            .catch(function (err) {
            logger.error('[AwsS3Implementation::DownloadFile] error:', err);
            return Promise.resolve(null);
        });
    };
    AwsS3Implementation.prototype.TestBucket = function (bucket) {
        var _this = this;
        var input = { Bucket: bucket };
        var command = new client_s3_1.HeadBucketCommand(input);
        var promiseAws = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.s3Client.send(command)];
                    case 1: return [2, (_a.sent())];
                }
            });
        }); };
        return promiseAws()
            .then(function (result) {
            return Promise.resolve(result ? true : false);
        })
            .catch(function (err) {
            logger.error('[AwsS3Implementation::TestBucket] error:', err);
            if (err.name === '403')
                return Promise.reject('SERVER_ERROR_S3_NOT_CLIENT');
            return Promise.resolve(false);
        });
    };
    AwsS3Implementation.prototype.TestPath = function (bucket, path) {
        var _this = this;
        var input = { Bucket: bucket, Key: this.CleanPath(path) };
        var command = new client_s3_1.GetObjectCommand(input);
        var promiseAws = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.s3Client.send(command)];
                    case 1: return [2, (_a.sent()).Body];
                }
            });
        }); };
        return promiseAws()
            .then(function (result) {
            return Promise.resolve(result ? true : false);
        })
            .catch(function (err) {
            logger.error('[AwsS3Implementation::TestPath] error:', err);
            return Promise.resolve(false);
        });
    };
    AwsS3Implementation.prototype.CleanPath = function (path) {
        if (path.startsWith('/'))
            path = path.slice(1);
        if (!path.match(/\.(mp3|wav|ogg)$/g)
            &&
                !path.endsWith('/'))
            path += '/';
        return path;
    };
    return AwsS3Implementation;
}());
exports.AwsS3Implementation = AwsS3Implementation;
