"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextMessageFromI6Data = exports.ExecutionVCCQuotes = exports.VCCQuote = void 0;
var VCCQuote = (function () {
    function VCCQuote(vcc, available) {
        if (vcc === void 0) { vcc = null; }
        if (available === void 0) { available = 0; }
        this.vcc = vcc;
        this.available = available;
        this.used = 0;
    }
    Object.defineProperty(VCCQuote.prototype, "reserved", {
        get: function () {
            var maxValue = 20;
            var value = Math.ceil(this.available * 15 / 100);
            return value <= maxValue ? value : maxValue;
        },
        enumerable: false,
        configurable: true
    });
    return VCCQuote;
}());
exports.VCCQuote = VCCQuote;
var ExecutionVCCQuotes = (function () {
    function ExecutionVCCQuotes() {
        this.quotes = [];
    }
    ExecutionVCCQuotes.prototype.GetVCCFreeAvailableQuote = function (vcc) {
        var quote = this.quotes.find(function (q) { return q.vcc === vcc; });
        return quote.available - quote.reserved;
    };
    ExecutionVCCQuotes.prototype.GetVCCTotalAvailableQuote = function (vcc) {
        var quote = this.quotes.find(function (q) { return q.vcc === vcc; });
        return quote.available;
    };
    ExecutionVCCQuotes.prototype.GetVCCUsedQuote = function (vcc) {
        return this.quotes.find(function (q) { return q.vcc === vcc; }).used;
    };
    ExecutionVCCQuotes.prototype.GetAllUsedQuote = function () {
        return this.quotes.reduce(function (acc, obj) { return acc + obj.used; }, 0);
    };
    ExecutionVCCQuotes.prototype.IncreaseVCCUsedQuote = function (vcc, use) {
        var quote = this.quotes.find(function (q) { return q.vcc === vcc; });
        quote.used += use;
    };
    return ExecutionVCCQuotes;
}());
exports.ExecutionVCCQuotes = ExecutionVCCQuotes;
var TextMessageFromI6Data = (function () {
    function TextMessageFromI6Data() {
        this.channel = null;
        this.fullMsg = null;
        this.msgTime = null;
        this.msgDate = null;
        this.msgNumber = null;
    }
    return TextMessageFromI6Data;
}());
exports.TextMessageFromI6Data = TextMessageFromI6Data;
