"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AverageGroupRatingNormService = void 0;
var log4js = require("log4js");
var mssql_service_1 = require("../db/mssql.service");
var promises_shared_1 = require("../shared/promises.shared");
var logger = log4js.getLogger('ServerScripts');
function AverageGroupRatingNormService(app) {
    app.get('/api/average_group_rating_norm/get_average_group_rating_norm/:initialDate/:endDate/:campaigns/:evaluationFormats/:evaluationPlans/:agents/:idGroup/:idSubGroup/:idAbility/:auditors?', function (req, res, next) {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        var instance = res.locals.instance;
        var initialDateString = req.params.initialDate ? req.params.initialDate : null;
        var endDateString = req.params.endDate ? req.params.endDate : null;
        var initialDate = initialDateString ? new Date(initialDateString) : null;
        var endDate = endDateString ? new Date(endDateString) : null;
        var campaigns = (req.params.campaigns && req.params.campaigns !== 'null' && req.params.campaigns !== 'undefined') ? req.params.campaigns : null;
        var evaluationFormats = (req.params.evaluationFormats && req.params.evaluationFormats !== 'null' && req.params.evaluationFormats !== 'undefined') ? req.params.evaluationFormats : null;
        var evaluationPlans = (req.params.evaluationPlans && req.params.evaluationPlans !== 'null' && req.params.evaluationPlans !== 'undefined') ? req.params.evaluationPlans : null;
        var agents = (req.params.agents && req.params.agents !== 'null' && req.params.agents !== 'undefined') ? req.params.agents : null;
        var idGroup = (req.params.idGroup && req.params.idGroup !== 'null' && req.params.idGroup !== '0') ? req.params.idGroup : null;
        var idSubGroup = (req.params.idSubGroup && req.params.idSubGroup !== 'null' && req.params.idSubGroup !== '0') ? req.params.idSubGroup : null;
        var idAbility = (req.params.idAbility && req.params.idAbility !== 'null' && req.params.idAbility !== '0') ? req.params.idAbility : null;
        var auditors = (req.params.auditors && req.params.auditors !== 'null' && req.params.auditors !== 'undefined') ? req.params.auditors : null;
        (0, promises_shared_1.DummyPromise)()
            .then(function (result) {
            if (initialDateString && initialDateString !== 'null' && endDateString && endDateString !== 'null') {
                return mssql_service_1.MSSql.GetAverageGroupRatingNorm(instance, initialDate, endDate, campaigns, evaluationFormats, evaluationPlans, agents, idGroup, idSubGroup, idAbility, auditors);
            }
            else {
                return null;
            }
        }).then(function (resultAverageGroupRating) {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'SERVER_SUCCESS_MESSAGE', data: resultAverageGroupRating });
        }).catch(function (err) {
            var clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            var errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: clientMsg, error: errorMsg });
        });
    });
}
exports.AverageGroupRatingNormService = AverageGroupRatingNormService;
