"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
var log4js = require("log4js");
var logger = log4js.getLogger('ServerScripts');
var auth_service_1 = require("./auth.service");
var batch_service_1 = require("./batch.service");
var batch_schedule_service_1 = require("./batch-schedule.service");
var custom_field_service_1 = require("./custom-field.service");
var diarization_service_1 = require("./diarization.service");
var dictionary_service_1 = require("./dictionary.service");
var efectivity_plan_service_1 = require("./efectivity-plan.service");
var entity_service_1 = require("./entity.service");
var home_service_1 = require("./home.service");
var profile_image_service_1 = require("./profile-image.service");
var report_service_1 = require("./report.service");
var role_service_1 = require("./role.service");
var task_service_1 = require("./task.service");
var team_performance_service_1 = require("./team-performance.service");
var user_service_1 = require("./user.service");
var api_user_service_1 = require("./api-user.service");
var client_service_1 = require("./client.service");
var process_service_1 = require("./process.service");
var idatha_service_1 = require("./idatha.service");
var feeling_service_1 = require("./feeling.service");
var category_service_1 = require("./category.service");
var neuro_linguistic_programming_service_1 = require("./neuro-linguistic-programming.service");
var template_service_1 = require("./template.service");
var generic_template_service_1 = require("./generic-template.service");
var generic_query_service_1 = require("./generic-query.service");
var nlu_service_1 = require("./nlu.service");
var intent_service_1 = require("./intent.service");
var utterance_service_1 = require("./utterance.service");
var train_service_1 = require("./train.service");
var environment_service_1 = require("./environment.service");
var allegro_service_1 = require("./allegro.service");
var audio_service_1 = require("./audio.service");
var exception_service_1 = require("./exception.service");
var country_service_1 = require("./country.service");
var tag_service_1 = require("./tag.service");
var study_service_1 = require("./study.service");
var word_blacklist_service_1 = require("./word-blacklist.service");
var vcc_service_1 = require("./vcc.service");
var linguistic_service_1 = require("./linguistic.service");
var platform_service_1 = require("./platform.service");
var account_service_1 = require("./account.service");
var ability_service_1 = require("./ability.service");
var agents_service_1 = require("./agents.service");
var attentionlevel_service_1 = require("./attentionlevel.service");
var average_group_rating_service_1 = require("./average-group-rating.service");
var campain_service_1 = require("./campain.service");
var evaluation_format_service_1 = require("./evaluation-format.service");
var interaction_service_1 = require("./interaction.service");
var tipification_service_1 = require("./tipification.service");
var top_best_agents_service_1 = require("./top-best-agents.service");
var evaluation_plan_service_1 = require("./evaluation-plan.service");
var evaluation_service_1 = require("./evaluation.service");
var group_service_1 = require("./group.service");
var auditor_service_1 = require("./auditor.service");
var subgroup_service_1 = require("./subgroup.service");
var average_group_rating_norm_service_1 = require("./average-group-rating-norm.service");
var top_worst_agents_service_1 = require("./top-worst-agents.service");
var interaction_type_service_1 = require("./interaction-type.service");
var campaign_fulfillment_service_1 = require("./campaign-fulfillment.service");
var workgroup_service_1 = require("./workgroup.service");
var workgroupsupervisor_service_1 = require("./workgroupsupervisor.service");
var disposition_code_service_1 = require("./disposition-code.service");
var interactions_by_type_service_1 = require("./interactions-by-type.service");
var io_service_1 = require("./io.service");
var global_search_service_1 = require("./global-search.service");
function init(app) {
    logger.info('Incializando servicios');
    (0, auth_service_1.AuthService)(app);
    (0, batch_service_1.BatchService)(app);
    (0, batch_schedule_service_1.BatchScheduleService)(app);
    (0, custom_field_service_1.CustomFieldService)(app);
    (0, diarization_service_1.DiarizationService)(app);
    (0, dictionary_service_1.DictionaryService)(app);
    (0, efectivity_plan_service_1.EfectivityPlanService)(app);
    (0, entity_service_1.EntityService)(app);
    (0, home_service_1.HomeService)(app);
    (0, profile_image_service_1.ProfileImageService)(app);
    (0, report_service_1.ReportService)(app);
    (0, role_service_1.RoleService)(app);
    (0, task_service_1.TaskService)(app);
    (0, team_performance_service_1.TeamPerformanceService)(app);
    (0, user_service_1.UserService)(app);
    (0, api_user_service_1.ApiUserService)(app);
    (0, client_service_1.ClientService)(app);
    (0, country_service_1.CountryService)(app);
    (0, process_service_1.ProcessService)(app);
    (0, idatha_service_1.IdathaService)(app);
    (0, feeling_service_1.FeelingService)(app);
    (0, category_service_1.CategoryService)(app);
    (0, neuro_linguistic_programming_service_1.NeuroLinguisticProgrammingService)(app);
    (0, template_service_1.TemplateService)(app);
    (0, generic_template_service_1.GenericTemplateService)(app);
    (0, generic_query_service_1.GenericQueryService)(app);
    (0, nlu_service_1.NLUService)(app);
    (0, intent_service_1.IntentService)(app);
    (0, utterance_service_1.UtteranceService)(app);
    (0, train_service_1.TrainService)(app);
    (0, environment_service_1.EnvironmentService)(app);
    (0, allegro_service_1.AllegroService)(app);
    (0, audio_service_1.AudioService)(app);
    (0, exception_service_1.ExceptionService)(app);
    (0, tag_service_1.TagService)(app);
    (0, study_service_1.StudyService)(app);
    (0, word_blacklist_service_1.WordBlacklistService)(app);
    (0, tag_service_1.TagService)(app);
    (0, vcc_service_1.VCCService)(app);
    (0, linguistic_service_1.LinguisticService)(app);
    (0, platform_service_1.PlatformService)(app);
    (0, account_service_1.AccountService)(app);
    (0, ability_service_1.AbilityService)(app);
    (0, agents_service_1.AgentsService)(app);
    (0, attentionlevel_service_1.AttentionLevelService)(app);
    (0, auditor_service_1.AuditorService)(app);
    (0, average_group_rating_norm_service_1.AverageGroupRatingNormService)(app);
    (0, average_group_rating_service_1.AverageGroupRatingService)(app);
    (0, campain_service_1.CampainService)(app);
    (0, campaign_fulfillment_service_1.CampaignFulfillmentService)(app);
    (0, disposition_code_service_1.DispositionCodeService)(app);
    (0, evaluation_format_service_1.EvaluationFormatService)(app);
    (0, evaluation_plan_service_1.EvaluationPlanService)(app);
    (0, evaluation_service_1.EvaluationService)(app);
    (0, group_service_1.GroupService)(app);
    (0, interactions_by_type_service_1.InteractionsByTypeService)(app);
    (0, interaction_service_1.InteractionService)(app);
    (0, interaction_type_service_1.InteractionTypeService)(app);
    (0, io_service_1.IOService)(app);
    (0, subgroup_service_1.SubgroupService)(app);
    (0, tipification_service_1.TipificationService)(app);
    (0, top_best_agents_service_1.TopBestAgentsService)(app);
    (0, top_worst_agents_service_1.TopWorstAgentsService)(app);
    (0, workgroup_service_1.WorkGroupService)(app);
    (0, workgroupsupervisor_service_1.WorkGroupSupervisorService)(app);
    (0, global_search_service_1.GlobalSearchService)(app);
}
exports.init = init;
