"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortObjectArrayByShuffle = exports.SortObjectArrayByValue = exports.GetSumFromObjectArray = exports.GetUniqueFromObjectArray = exports.GetUniqueFromArray = exports.GetCompareItemsFromObjectArray = void 0;
function GetCompareItemsFromObjectArray(oldArr, newArr, keyPropertyOA, keyPropertyNA) {
    if (!keyPropertyNA)
        keyPropertyNA = keyPropertyOA;
    if (!oldArr)
        oldArr = [];
    if (!newArr)
        newArr = [];
    var newItems = [];
    var oldItems = [];
    var removedItems = [];
    oldArr.map(function (oa) {
        if (!newArr.find(function (na) { return na[keyPropertyNA] === oa[keyPropertyOA]; }))
            removedItems.push(oa);
        else
            oldItems.push(oa);
    });
    newArr.map(function (na) {
        if (!oldArr.find(function (oa) { return oa[keyPropertyOA] === na[keyPropertyNA]; }))
            newItems.push(na);
    });
    return {
        new: newItems,
        old: oldItems,
        removed: removedItems
    };
}
exports.GetCompareItemsFromObjectArray = GetCompareItemsFromObjectArray;
function GetUniqueFromArray(arr) {
    var reducedArray = arr.reduce(function (unique, item) {
        return unique.includes(item) ? unique : __spreadArray(__spreadArray([], unique, true), [item], false);
    }, []);
    return reducedArray;
}
exports.GetUniqueFromArray = GetUniqueFromArray;
function GetUniqueFromObjectArray(arr, value) {
    var unique = arr
        .map(function (e) { return e[value]; })
        .map(function (e, i, final) { return final.indexOf(e) === i && i; })
        .filter(function (e) { return arr[e]; }).map(function (e) { return arr[e]; });
    return unique;
}
exports.GetUniqueFromObjectArray = GetUniqueFromObjectArray;
function GetSumFromObjectArray(arr, property) {
    var total = 0;
    total = arr.map(function (item) { return item[property]; }).reduce(function (prev, curr) { return prev + curr; }, 0);
    return total;
}
exports.GetSumFromObjectArray = GetSumFromObjectArray;
function SortObjectArrayByValue(arr, property, sortType) {
    var sortedObjectArray = [];
    switch (sortType) {
        case 'A':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] < b[property] ? -1 : 1); });
            break;
        case 'D':
            sortedObjectArray = arr.sort(function (a, b) { return (a[property] > b[property] ? -1 : 1); });
            break;
    }
    return sortedObjectArray;
}
exports.SortObjectArrayByValue = SortObjectArrayByValue;
function SortObjectArrayByShuffle(arr) {
    var _a;
    var currentIndex = arr.length, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        _a = [
            arr[randomIndex], arr[currentIndex]
        ], arr[currentIndex] = _a[0], arr[randomIndex] = _a[1];
    }
    return arr;
}
exports.SortObjectArrayByShuffle = SortObjectArrayByShuffle;
